import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The superclass of all actors that need to scroll (i.e. all the actors except Player)
 * 
 */
public abstract class Front extends Objects
{
    public int scrollX; //The variable used when scrolling.

    public Front()
    {
        scrollX = 0;
    }

    /**
     * Used for setting the actor's location.
     */
    public void setLocation()
    {
        setLocation(getX() + scrollX, getY());
    }
    
    public void checkKeyPress(int amount)
    {
        ScrollingWorld theWorld = (ScrollingWorld) getWorld();
        if (theWorld.checkScroll() == true)
        {
            scrollX = amount * theWorld.scrollDirection;
        }
    }
    
    /**
     * A call to the following should be in all scrolling actor's act methods.
     */
    public void scrollingMethods()
    {
        checkKeyPress(4);
        setLocation();
    }
}