import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class HealthBar here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class HealthBar extends Statics
{
    private static final Color DEFAULT_COLOR = new Color(0, 255, 0, 128);

    private Color barColor = DEFAULT_COLOR;
    private GreenfootImage barImage;
    private int width;
    private int height;
    private int percentFilled;

    public HealthBar()
    {
        this (25, 100);
    }

    public HealthBar(int newWidth, int newHeight)
    {
        width = newWidth;
        height = newHeight;
        makeImage();
    }

    /**
     * Act - do whatever the HealthBar wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    

    private void makeImage()
    {
        barImage = new GreenfootImage(width, height);
        barImage.setColor(Color.WHITE);
        barImage.drawRect(0, 0, width - 1, height - 1);
        int barHeight = (int) (percentFilled / 100.0 * (height - 1));
        barImage.setColor(barColor);
        barImage.fillRect(1, 101 - percentFilled, width - 2, barHeight - 1);
        setImage(barImage);
    }

    public void setPercentageFilled(int percentageFilled)
    {
        if (percentageFilled < 0)
        {
            percentageFilled = 0;
        }
        else if (percentageFilled > 100)
        {
            percentageFilled = 100;
        }
        else if (percentFilled != percentageFilled)
        {
            percentFilled = percentageFilled;
            makeImage();
        }
    }

    public void setBarColor(Color newBarColor)
    {
        if (newBarColor == null)
        {
            newBarColor = DEFAULT_COLOR;
        }
        if (!barColor.equals(newBarColor))
        {
            barColor = newBarColor;
            makeImage();
        }
    }

    public int getWidth() 
    {
        return width;
    }

    public int getHeight() 
    {
        return height;
    }
}
