import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Foreground
{
    private GreenfootImage imager1, imager2, imager3, imager4, imager5, imager6, 
    imager7, imager8, imager9, imager10, imager11, imager12, imagestr, imagecr1, imagecr2,
    imagel1, imagel2, imagel3, imagel4, imagel5, imagel6, imagel7, imagel8, imagel9, 
    imagel10, imagel11, imagel12, imagejr01, imagejr02, imagejr03, imagejr04, imagejr05, 
    imagejr06, imagejl01, imagejl02, imagejl03, imagejl04, imagejl05, imagejl06, imagestl;
    private int stepCount = 0;

    private static final int FOREGROUNDSCROLL = 4;
    //Player speed
    private static final int SPEED = 0;
    //World gravity
    private static final int GRAVITY = 1;
    //Max speed an object can fall at
    private static final int MAXFALLSPEED = 17;
    //Speed of animations
    private static final int ANIMATIONSPEED = 5;
    //strength of jumping ability
    private static final int JUMPSPEED = 18;
    //Current vertical speed.
    private int vSpeed = 0; 

    private int healthCount = 100;

    public boolean canMoveRight = true;
    public boolean canMoveLeft = true;

    private int refireTime = 0;
    private HealthBar health;

    private int invincibilityTimer = 0;

    private boolean inWorld = false;

    /**
     * Constructor to initializes the images use to animate the player.
     */
    public Player()
    {
        imager1 =  new GreenfootImage("runr01.png");
        imager2 =  new GreenfootImage("runr02.png");
        imager3 =  new GreenfootImage("runr03.png");
        imager4 =  new GreenfootImage("runr04.png");
        imager5 =  new GreenfootImage("runr05.png");
        imager6 =  new GreenfootImage("runr06.png");
        imager7 =  new GreenfootImage("runr07.png");
        imager8 =  new GreenfootImage("runr08.png");
        imager9 =  new GreenfootImage("runr09.png");
        imager10 =  new GreenfootImage("runr10.png");
        imager11 =  new GreenfootImage("runr11.png");
        imager12 =  new GreenfootImage("runr12.png");
        imagel1 =  new GreenfootImage("runl01.png");
        imagel2 =  new GreenfootImage("runl02.png");
        imagel3 =  new GreenfootImage("runl03.png");
        imagel4 =  new GreenfootImage("runl04.png");
        imagel5 =  new GreenfootImage("runl05.png");
        imagel6 =  new GreenfootImage("runl06.png");
        imagel7 =  new GreenfootImage("runl07.png");
        imagel8 =  new GreenfootImage("runl08.png");
        imagel9 =  new GreenfootImage("runl09.png");
        imagel10 =  new GreenfootImage("runl10.png");
        imagel11 =  new GreenfootImage("runl11.png");
        imagel12 =  new GreenfootImage("runl12.png");
        imagestr =  new GreenfootImage("standr.png");
        imagestl =  new GreenfootImage("standl.png");
        imagecr1 = new GreenfootImage("crouch1.png");
        imagecr2 = new GreenfootImage("crouch2.png");
        imagejr01 = new GreenfootImage("jumpr01.png");
        imagejr02 = new GreenfootImage("jumpr02.png");
        imagejr03 = new GreenfootImage("jumpr03.png");
        imagejr04 = new GreenfootImage("jumpr04.png");
        imagejr05 = new GreenfootImage("jumpr05.png");
        imagejr06 = new GreenfootImage("jumpr06.png");
        imagejl01 = new GreenfootImage("jumpl01.png");
        imagejl02 = new GreenfootImage("jumpl02.png");
        imagejl03 = new GreenfootImage("jumpl03.png");
        imagejl04 = new GreenfootImage("jumpl04.png");
        imagejl05 = new GreenfootImage("jumpl05.png");
        imagejl06 = new GreenfootImage("jumpl06.png");
    }

    public void act() 
    {
        checkControl();
        checkHorizontalCollision();
        checkGround();
        reduceRefireTime();
        checkState();
        health.setPercentageFilled(healthCount);
        checkDeath();
        checkInvincibility();
    }

    public void checkInvincibility()
    {
        if (invincibilityTimer > 0 && invincibilityTimer % 4 == 0)
        {
            getImage().setTransparency(0);
        }
        if (invincibilityTimer < 0 || invincibilityTimer % 4 != 0)
        {
            getImage().setTransparency(255);
        }
    }

    public void checkState()
    {
        ScrollingWorld theWorld = (ScrollingWorld) getWorld();
        invincibilityTimer--;
        Actor fire = getOneIntersectingObject(Fire.class);
        Actor healthRefill = getOneIntersectingObject(Health.class);
        if (fire != null && invincibilityTimer < 1)
        {
            healthCount = healthCount - 10;
            invincibilityTimer = 40;
            theWorld.removeObject(fire);
        }
        if (healthRefill != null)
        {
            healthCount = 100;
            theWorld.removeObject(healthRefill);
        }
    }

    public void checkDeath()
    {
        ScrollingWorld theWorld = (ScrollingWorld) getWorld();
        if (healthCount < 0)
        {
            theWorld.changeLifeTotal(1);
            theWorld.resetMap();
            theWorld.checkLifeTotal();
        }
        else if (getY() > 650)
        {
            theWorld.changeLifeTotal(1);
            theWorld.resetMap();
            theWorld.checkLifeTotal();
        }
    }

    public void addedToWorld(World world)
    {
        ScrollingWorld theWorld = (ScrollingWorld) getWorld();
        if (theWorld.getObjects(HealthBar.class).size() < 1)
        {
            health = new HealthBar(20, 100);
            health.setPercentageFilled(100);
            health.setBarColor(new Color(255, 50, 50, 200));
            int x = health.getWidth() / 2 + 20;
            int y = health.getHeight() / 2 + 20;
            world.addObject(health, x, y);
        }
    }

    public void fall()
    {
        vSpeed = vSpeed + GRAVITY;
        if (vSpeed > MAXFALLSPEED)
        {
            vSpeed = MAXFALLSPEED;
        }
        //setLocation (getX(), getY() + vSpeed );
        checkVerticalCollision();
        animateJump();
    }

    /**
     * Checks how far the player if going to move vertically.
     */
    private void checkVerticalCollision()
    {
        int falldistance = vSpeed;
        int checkDistance = 0;
        if (vSpeed > 0)
        {
            checkDistance = (vSpeed + (getImage().getHeight() / 2));
        }
        else
        {
            checkDistance = (vSpeed - (getImage().getHeight() / 2));
        }
        Actor inWay = getOneObjectAtOffset(0, checkDistance, Ground.class);
        Actor inWay2 = getOneObjectAtOffset((getImage().getWidth() / 2), checkDistance, Ground.class);
        Actor inWay3 = getOneObjectAtOffset(0 - getImage().getWidth() / 2, checkDistance, Ground.class);
        if (inWay == null && inWay2 == null && inWay3 == null)
        {
            setLocation (getX(), getY() + vSpeed );
        }
        else
        {
            if (inWay != null)
            {
                setOnSurface(inWay);
            }
            else
            {
                if (inWay2 != null)
                {
                    setOnSurface(inWay2);
                }
                else
                {
                    if (inWay3 != null)
                    {
                        setOnSurface(inWay3);
                    }
                }
            }
        }
    }

    public void checkHorizontalCollision()
    {
        checkRightCollision();
        checkLeftCollision();
    }

    public void checkRightCollision()
    {
        int checkXDistance = 0;
        checkXDistance = (FOREGROUNDSCROLL + (getImage().getWidth() / 2));
        Actor inWay = getOneObjectAtOffset(checkXDistance, 0, Ground.class);
        Actor inWay2 = getOneObjectAtOffset(checkXDistance, -30, Ground.class);
        Actor inWay3 = getOneObjectAtOffset(checkXDistance, 30, Ground.class);
        if (inWay == null && inWay2 == null && inWay3 == null)
        {
            canMoveRight = true;
        }
        else
        {
            canMoveRight = false;
        }
    }

    public void checkLeftCollision()
    {
        int checkDistance = 0;
        checkDistance = (FOREGROUNDSCROLL + (getImage().getWidth() / 2));
        Actor inWay = getOneObjectAtOffset(-checkDistance, 0, Ground.class);
        Actor inWay2 = getOneObjectAtOffset(-checkDistance, -30, Ground.class);
        Actor inWay3 = getOneObjectAtOffset(-checkDistance, 30, Ground.class);
        if (inWay == null && inWay2 == null && inWay3 == null)
        {
            canMoveLeft = true;
        }
        else
        {
            canMoveLeft = false;
        }
    }

    public void setOnSurface(Actor surface)
    {
        int objectSurface = (surface.getImage().getHeight() + getImage().getHeight()) / 2;
        int againstObject = 0;

        if (surface.getY() > getY())
        {
            againstObject = surface.getY() - objectSurface;
        }
        else
        {
            againstObject = surface.getY() + objectSurface;
        }

        setLocation(getX(), againstObject);
        vSpeed = 0;
    }

    public void animateJump()
    {
        if (vSpeed > -17 && vSpeed < -10)
        {
            if (directionFacing == RIGHT)
            {
                setImage (imagejr01);
            }
            else
            {
                setImage (imagejl01);
            }
        }
        if (vSpeed > -11 && vSpeed < -5)
        {
            if (directionFacing == RIGHT)
            {
                setImage (imagejr02);
            }
            else
            {
                setImage (imagejl02);
            }
        }
        if (vSpeed > -6 && vSpeed < -1)
        {
            if (directionFacing == RIGHT)
            {
                setImage (imagejr03);
            }
            else
            {
                setImage (imagejl03);
            }
        }
        if (vSpeed > -2 && vSpeed < 15)
        {
            if (directionFacing == RIGHT)
            {
                setImage (imagejr04);
            }
            else
            {
                setImage (imagejl04);
            }
        }
        if (vSpeed > 14 && vSpeed < 17)
        {
            if (directionFacing == RIGHT)
            {
                setImage (imagejr05);
            }
            else
            {
                setImage (imagejl05);
            }
        }
        if (vSpeed > 16)
        {
            if (directionFacing == RIGHT)
            {
                setImage (imagejr06);
            }
            else
            {
                setImage (imagejl06);
            }
        }
    }

    public void checkGround()
    {
        if (onGround() )
        {
            vSpeed = 0;
        }
        else
        {
            fall();
        }
    }

    public boolean onGround()
    {
        Actor under = getOneObjectAtOffset (0, getImage().getHeight() / 2, Ground.class);
        Actor underleft = getOneObjectAtOffset (0 - getImage().getWidth() / 2, 
                getImage().getHeight() / 2, Ground.class);
        Actor underright = getOneObjectAtOffset (getImage().getWidth() / 2, 
                getImage().getHeight() / 2, Ground.class);
        if (under == null && underleft == null && underright == null)
        {
            return false;
        }
        else
        {
            return true;
        }
    }

    public void jump()
    {
        vSpeed = -JUMPSPEED;
        fall();
    }

    public boolean notCrouched()
    {
        if (getImage() == imagecr2)
        {
            return false;
        }
        else
        {
            return true;
        }
    }

    public void reduceRefireTime()
    {
        if (refireTime > 0)
        {
            refireTime = refireTime - 1;
        }
    }

    public void checkControl()
    {
        ScrollingWorld theWorld = (ScrollingWorld) getWorld();
        if (theWorld.inControl == true)
        {
            checkInput();
        }
    }

    /**
     * Check for directional inputs.  move the desired direction and alternate between images. 
     */
    public void checkInput()
    {
        ScrollingWorld theWorld = (ScrollingWorld) getWorld();
        String key = Greenfoot.getKey();
        if (key == null)
        {
            canMoveRight = true;
            canMoveLeft = true;
            if (directionFacing == RIGHT)
            {
                setImage (imagestr);
            }
            if (directionFacing == LEFT)
            {
                setImage (imagestl);
            }
        }

        if (key == ("space"))
        {
            if (refireTime == 0)
            {
                if (directionFacing == RIGHT)
                {
                    theWorld.addObject(new Fire(1), (getX() + getImage().getWidth() - 25), getY());
                    refireTime = 20;
                }
                if (directionFacing == LEFT)
                {
                    theWorld.addObject(new Fire(-1), (getX() - getImage().getWidth() + 25), getY());
                    refireTime = 20;
                }
            }
        }

        if (Greenfoot.isKeyDown("up") && onGround())
        {
            jump();
        }
        if (Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right"))
        {
            directionFacing = LEFT;
            if (onGround())
            {
                stepCount++;
                if (stepCount > 1 && stepCount < 4)
                {
                    setImage (imagel1);
                }
                if (stepCount > 4 && stepCount < 7)
                {
                    setImage (imagel2);
                }
                if (stepCount > 7 && stepCount < 11)
                {
                    setImage (imagel3);
                }
                if (stepCount > 10 && stepCount < 14)
                {
                    setImage (imagel4);
                }
                if (stepCount > 13 && stepCount < 17)
                {
                    setImage (imagel5);
                }
                if (stepCount > 16 && stepCount < 20)
                {
                    setImage (imagel6);
                }
                if (stepCount > 19 && stepCount < 23)
                {
                    setImage (imagel7);
                }
                if (stepCount > 22 && stepCount < 26)
                {
                    setImage (imagel8);
                }
                if (stepCount > 25 && stepCount < 29)
                {
                    setImage (imagel9);
                }
                if (stepCount > 28 && stepCount < 32)
                {
                    setImage (imagel10);
                }
                if (stepCount > 31 && stepCount < 35)
                {
                    setImage (imagel11);
                }
                if (stepCount > 34 && stepCount < 37)
                {
                    setImage (imagel12);
                }
                if (stepCount ==37 )
                {
                    setImage (imagel4);
                    stepCount = 11;
                }
            }
        }
        if (Greenfoot.isKeyDown("right") && !Greenfoot.isKeyDown("left"))
        {
            directionFacing = RIGHT;
            if (onGround())
            {
                stepCount++;
                if (stepCount > 1 && stepCount < 5)
                {
                    setImage (imager1);
                }
                if (stepCount > 4 && stepCount < 8)
                {
                    setImage (imager2);
                }
                if (stepCount > 7 && stepCount < 11)
                {
                    setImage (imager3);
                }
                if (stepCount > 10 && stepCount < 14)
                {
                    setImage (imager4);
                }
                if (stepCount > 13 && stepCount < 17)
                {
                    setImage (imager5);
                }
                if (stepCount > 16 && stepCount < 20)
                {
                    setImage (imager6);
                }
                if (stepCount > 19 && stepCount < 23)
                {
                    setImage (imager7);
                }
                if (stepCount > 22 && stepCount < 26)
                {
                    setImage (imager8);
                }
                if (stepCount > 25 && stepCount < 29)
                {
                    setImage (imager9);
                }
                if (stepCount > 28 && stepCount < 32)
                {
                    setImage (imager10);
                }
                if (stepCount > 31 && stepCount < 35)
                {
                    setImage (imager11);
                }
                if (stepCount > 34 && stepCount < 37)
                {
                    setImage (imager12);
                }
                if (stepCount ==37 )
                {
                    setImage (imager4);
                    stepCount = 11;
                }
            }
        }
    }
}
